## satdump 1.2.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake")
include(CheckCXXSourceCompiles)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})

if(MSVC OR BUILD_MSVC)
    set(VCPKG_APPLOCAL_DEPS CACHE BOOL FALSE)
endif()

project(SatDump)

option(BUILD_GUI "Build the GUI" ON)
option(BUILD_TESTING "Build the testing program" OFF)
option(BUILD_TOOLS "Build the tools programs" OFF)
option(BUILD_ZIQ "Build support for the custom ZIQ format" ON)
option(BUILD_ZIQ2 "Build support for the custom ZIQ2 format (Very WIP)" OFF)
option(BUILD_MSVC "Build for Windows with MSVC" OFF) # Seems like "MSVC" as a macro messed up below for some reason...
option(BUILD_OPENCL "Build with OpenCL GPU Accelerations" ON)
option(BUILD_OPENMP "Build with OpenMP Optimizations" ON)
option(BUILD_DOCS "Build with Doxygen Documentation" OFF)
option(ENABLE_INSTALL "Enable INSTALL TARGET" ON)

if(ANDROID)
    # Build settings
    set(BUILD_OPENMP OFF)
    set(OPENCL_FOUND 1)
endif()

# Set default install prefix
include(GNUInstallDirs) #Retruns good defaults on non-GNU systems as well
if(UNIX)
    if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
        if(APPLE)
            set(CMAKE_INSTALL_PREFIX /usr/local CACHE PATH "Set CMAKE Default to /usr/local" FORCE)
        else()
            set(CMAKE_INSTALL_PREFIX /usr CACHE PATH "Set CMAKE Default to /usr" FORCE)
        endif()
    endif(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
endif()

if(APPLE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++17")
    link_directories(vcpkg/installed/osx-satdump/lib)

    # Jemalloc
    find_package(Jemalloc REQUIRED)
    include_directories(${JEMALLOC_INCLUDE_DIR})
    link_libraries(${JEMALLOC_LIBRARY})

endif()

if(UNIX)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra")
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -g")
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O3")

    if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-psabi")
    endif()

    if(BUILD_OPENMP)
        message("Compiling with OpenMP support!")
        if(APPLE)
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-command-line-argument -Xpreprocessor")
        endif()
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fopenmp")
    endif()

    find_package(ZSTD)

    if((NOT ZSTD_FOUND) AND BUILD_ZIQ AND (NOT ANDROID))
        message("ZIQ Was enabled but libzstd was not found!")
        set(BUILD_ZIQ OFF)
    endif()
else()
    # set(CMAKE_CXX_FLAGS "-Wall")
    # set(CMAKE_CXX_FLAGS_DEBUG "-g")
    set(CMAKE_CXX_FLAGS_RELEASE "-O2")
endif()

if(MSVC OR BUILD_MSVC)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS -D_WINSOCK_DEPRECATED_NO_WARNINGS -D_CRT_NONSTDC_NO_WARNINGS)
    add_compile_definitions(_SILENCE_ALL_CXX17_DEPRECATION_WARNINGS)

    if(BUILD_OPENMP)
        message("Compiling with OpenMP support!")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /openmp")
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /openmp")
    endif()

    # This should be the default, but sometimes it isn't apparently
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MD")
    set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} /MD")
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /MDd")
    set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} /MDd")

    # Speed up this to object-level, Suppress type conversion warnings, suppress
    # POSIX function warnings, suppress warnings about DLL-exported functions, and
    # Suppress warnings about template methods defined in another C++ file
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP8 /EHsc /wd4305 /wd4267 /wd4244 /wd4273 /wd4661")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /MP8 /EHsc /wd4305 /wd4267 /wd4244 /wd4273 /wd4661")

    #Suppress pointless (to us) warnings about DLL-exported functions
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /ignore:4286,4217")
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} /ignore:4286,4217")
    set(CMAKE_STATIC_LINKER_FLAGS "${CMAKE_STATIC_LINKER_FLAGS} /ignore:4286,4217")

    set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
    include_directories(vcpkg/installed/${VCPKG_TARGET_TRIPLET}/include)
    link_directories(vcpkg/installed/${VCPKG_TARGET_TRIPLET}/lib)
endif()

project(SatDump VERSION "1.2.2")

# Check if the current commit has a tag
execute_process(
    COMMAND git name-rev --name-only --tags HEAD
    WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}
    OUTPUT_VARIABLE GIT_HAS_TAG
    OUTPUT_STRIP_TRAILING_WHITESPACE
)

# Get the latest abbreviated commit hash of current branch
execute_process(
    COMMAND git log -1 --format=%h
    WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}
    OUTPUT_VARIABLE GIT_HASH
    OUTPUT_STRIP_TRAILING_WHITESPACE
)

# Set version
if(GIT_HAS_TAG STREQUAL "undefined" OR GIT_HAS_TAG STREQUAL "nightly")
    message("-- Commit has no tag/nightly tag (${GIT_HAS_TAG}). Assume dev build")
    set(SATDUMP_VERSION "${PROJECT_VERSION}-${GIT_HASH}")
else()
    message("-- Commit has tag (${GIT_HAS_TAG}). Assume release build")
    set(SATDUMP_VERSION "${PROJECT_VERSION}")
endif()
add_compile_definitions(SATDUMP_VERSION="${SATDUMP_VERSION}")

# Used for error messages
string(LENGTH "${CMAKE_SOURCE_DIR}/" SOURCE_PATH_SIZE)
add_compile_definitions(SOURCE_PATH_SIZE=${SOURCE_PATH_SIZE})

if(ANDROID)
    add_compile_definitions(ANDROID_ABI_LIB="${ANDROID_ABI}")
endif()

# Check we have OpenCL
if(NOT ANDROID)
    find_package(OpenCL)
endif()

if(OPENCL_FOUND AND BUILD_OPENCL)
    message("OpenCL Found! SatDump will support accelerated GPU computing.")
else()
    message("OpenCL NOT found or disabled!")
    set(BUILD_OPENCL OFF)
endif()

# For good measure
if(BUILD_ZIQ)
    message("Building with ZIQ Support")
endif()

if(BUILD_ZIQ2)
    message("Building with ZIQ2 Support")
endif()

# If in debug, set the macro
if(CMAKE_BUILD_TYPE STREQUAL "Debug")
    add_compile_definitions(BUILD_IS_DEBUG=1)
    message("")
    message("██████╗  █████╗ ███╗   ██╗ ██████╗ ███████╗██████╗ ")
    message("██╔══██╗██╔══██╗████╗  ██║██╔════╝ ██╔════╝██╔══██╗")
    message("██║  ██║███████║██╔██╗ ██║██║  ███╗█████╗  ██████╔╝")
    message("██║  ██║██╔══██║██║╚██╗██║██║   ██║██╔══╝  ██╔══██╗")
    message("██████╔╝██║  ██║██║ ╚████║╚██████╔╝███████╗██║  ██║")
    message("╚═════╝ ╚═╝  ╚═╝╚═╝  ╚═══╝ ╚═════╝ ╚══════╝╚═╝  ╚═╝")
    message("Building SatDump in Debug mode!")
    message("")
endif()

# Check system has <filesystem>
check_cxx_source_compiles("#include <filesystem>\n int main() { return 0; }" STD_HAS_FILESYSTEM)

if(NOT STD_HAS_FILESYSTEM)
    include_directories(std_filesystem)
endif()

add_subdirectory(src-core)
add_subdirectory(src-cli)

if(BUILD_GUI)
    message("Building the GUI")
    add_subdirectory(src-interface)

    if(NOT ANDROID)
        add_subdirectory(src-ui)
    endif()
endif()

if(BUILD_TESTING)
    add_subdirectory(src-testing)
endif()

if(BUILD_TOOLS)
    add_subdirectory(tools)
endif()

add_subdirectory(plugins)

# Install configuration
if((NOT ANDROID) AND ENABLE_INSTALL)
    install(DIRECTORY ${CMAKE_SOURCE_DIR}/pipelines DESTINATION share/satdump)
    install(DIRECTORY ${CMAKE_SOURCE_DIR}/resources DESTINATION share/satdump)
    install(FILES ${CMAKE_SOURCE_DIR}/satdump_cfg.json DESTINATION share/satdump)
    install(FILES ${CMAKE_SOURCE_DIR}/icon.png DESTINATION share/satdump)
    configure_file(${CMAKE_SOURCE_DIR}/satdump.desktop ${CMAKE_CURRENT_BINARY_DIR}/satdump.desktop @ONLY)

    if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
        install(FILES ${CMAKE_CURRENT_BINARY_DIR}/satdump.desktop DESTINATION share/applications)
    endif()

    # Create uninstall target
    configure_file(${CMAKE_SOURCE_DIR}/cmake/cmake_uninstall.cmake ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake @ONLY)
    add_custom_target(uninstall ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)

    # CPack Configuration
    set(CPACK_PACKAGE_NAME ${PROJECT_NAME} CACHE STRING "satdump-${PROJECT_VERSION}")
    set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "A satellite data processing software" CACHE STRING "")
    set(CPACK_PACKAGE_VENDOR "SatDump")
    set(CPACK_PACKAGE_CONTACT "Aang23")

    set(CPACK_DEBIAN_PACKAGE_DEPENDS "libfftw3-bin, libvolk-bin | libvolk2-bin, libpng16-16, libnng1, librtlsdr0 | librtlsdr2, libhackrf0, libairspy0, libairspyhf1, libglfw3 | libglfw3-wayland, libzstd1, libjemalloc2 | libjemalloc1, libportaudiocpp0, libhdf5-hl-100t64 | libhdf5-hl-100 | libhdf5-103 | libhdf5-100")
    set(CPACK_DEBIAN_PACKAGE_RECOMMENDS "libomp5-14, ocl-icd-libopencl1, intel-opencl-icd, mesa-opencl-icd")

    set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE")
    set(CPACK_RESOURCE_FILE_README "${CMAKE_CURRENT_SOURCE_DIR}/README.md")

    if(MSVC OR BUILD_MSVC)
        set(CPACK_PACKAGING_INSTALL_PREFIX "/")
    else()
        set(CPACK_PACKAGING_INSTALL_PREFIX "/usr")
    endif()

    #set(CPACK_PACKAGE_VERSION_MAJOR ${PROJECT_VERSION_MAJOR})
    #set(CPACK_PACKAGE_VERSION_MINOR ${PROJECT_VERSION_MINOR})
    #set(CPACK_PACKAGE_VERSION_PATCH ${PROJECT_VERSION_PATCH})
    set(CPACK_PACKAGE_VERSION ${SATDUMP_VERSION})

    if(MSVC OR BUILD_MSVC)
        # Customize NSIS template
        file(READ "${CMAKE_ROOT}/Modules/Internal/CPack/NSIS.template.in" NSIS_template)
        set(CREATE_ICONS_REPLACE "  SetOutPath \"$INSTDIR\\bin\"\n@CPACK_NSIS_CREATE_ICONS@\n@CPACK_NSIS_CREATE_ICONS_EXTRA@\n  SetOutPath \"$INSTDIR\"")
        string(CONCAT INSTALLDIR_REPLACE "  InstallDir \"@CPACK_NSIS_INSTALL_ROOT@\\@CPACK_PACKAGE_INSTALL_DIRECTORY@\""
            "\n  InstallDirRegKey HKLM Software\\@CPACK_PACKAGE_VENDOR@\\@CPACK_PACKAGE_INSTALL_REGISTRY_KEY@ \"\"")
        string(REPLACE "@CPACK_NSIS_CREATE_ICONS@\n@CPACK_NSIS_CREATE_ICONS_EXTRA@" "${CREATE_ICONS_REPLACE}" NSIS_template "${NSIS_template}")
        string(REPLACE "  InstallDir \"@CPACK_NSIS_INSTALL_ROOT@\\@CPACK_PACKAGE_INSTALL_DIRECTORY@\"" "${INSTALLDIR_REPLACE}" NSIS_template "${NSIS_template}")
        file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/NSIS.template.in" "${NSIS_template}")
        set(CPACK_MODULE_PATH "${CMAKE_CURRENT_BINARY_DIR}")

        # Generate Installer
        set(CPACK_GENERATOR NSIS)
        set(CPACK_PACKAGE_INSTALL_DIRECTORY SatDump)
        set(CPACK_NSIS_MANIFEST_DPI_AWARE ON)
        set(CPACK_NSIS_ENABLE_UNINSTALL_BEFORE_INSTALL ON)
        set(CPACK_NSIS_MODIFY_PATH ON)
        set(CPACK_NSIS_BRANDING_TEXT "SatDump - General Purpose Satellite Data Processor")
        set(CPACK_NSIS_MUI_HEADERIMAGE "${PROJECT_SOURCE_DIR}\\\\windows\\\\installer-header.bmp")
        set(CPACK_NSIS_MUI_ICON "${PROJECT_SOURCE_DIR}\\\\windows\\\\icon.ico")
        if(BUILD_GUI)
            set(CPACK_NSIS_INSTALLED_ICON_NAME "bin\\\\satdump-ui.exe")
            set(CPACK_PACKAGE_EXECUTABLES ${CPACK_PACKAGE_EXECUTABLES} "satdump-ui" "SatDump")
            list(APPEND CPACK_NSIS_CREATE_ICONS_EXTRA "CreateShortCut \\\"$DESKTOP\\\\SatDump.lnk\\\" \\\"$INSTDIR\\\\bin\\\\satdump-ui.exe\\\"")
            list(APPEND CPACK_NSIS_DELETE_ICONS_EXTRA "Delete \\\"$DESKTOP\\\\SatDump.lnk\\\"")
        endif()
        if(PLUGIN_REMOTE_SDR_SUPPORT)
            set(CPACK_PACKAGE_EXECUTABLES ${CPACK_PACKAGE_EXECUTABLES} "satdump_sdr_server" "SatDump SDR Server")
        endif()

        install(RUNTIME_DEPENDENCY_SET satdump_deps
            PRE_EXCLUDE_REGEXES
                "api-ms-.*"
                "ext-ms-.*"
                "^hvsifiletrust\\.dll$"
                "^pdmutilities\\.dll$"
                "^vc.*"
                "^msvcp.*"
                "^concrt.*"
                "satdump_core.dll"
                "satdump_interface.dll"
            POST_EXCLUDE_REGEXES
            ".*system32/.*\\.dll"
            DIRECTORIES
            "${PROJECT_SOURCE_DIR}/vcpkg/installed/${VCPKG_TARGET_TRIPLET}/bin"
        )

=== plugins/CMakeLists.txt ===
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/plugins)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/plugins)

# We need those to be available for plugins!
include_directories(../src-core ../src-interface)

option(PLUGINS_ALL "Enable all plugins by default" ON)

option(PLUGIN_SPACEX "Enable the SpaceX support plugin" OFF)

# ##############################################################################
option(PLUGIN_SCRIPTING "Enable the scripting support plugin (EXPERIMENTAL)"
       OFF)

if(PLUGIN_SCRIPTING) # OR PLUGINS_ALL)
  add_subdirectory(scripting_support)
endif()

# ##############################################################################
if(PLUGIN_SPACEX OR PLUGINS_ALL)
  add_subdirectory(spacex_support)
endif()

option(PLUGIN_FY2 "Enable the FengYun-2 (S-VISSR, etc) support plugin" OFF)

if(PLUGIN_FY2 OR PLUGINS_ALL)
  add_subdirectory(fengyun2_support)
endif()

option(PLUGIN_FY3 "Enable the FengYun-3 (AHRPT, MPT, DPT, etc) support plugin"
       OFF)

if(PLUGIN_FY3 OR PLUGINS_ALL)
  add_subdirectory(fengyun3_support)
endif()

option(PLUGIN_FY4 "Enable the FengYun-4 (LRIT, HRIT) support plugin" OFF)

if(PLUGIN_FY4 OR PLUGINS_ALL)
  add_subdirectory(fengyun4_support)
endif()

option(PLUGIN_PROBA "Enable the Proba (1, 2, V, etc) support plugin" OFF)

if(PLUGIN_PROBA OR PLUGINS_ALL)
  add_subdirectory(proba_support)
endif()

option(PLUGIN_EOS "Enable the EOS (Aqua, Terra, Aura) support plugin" OFF)

if(PLUGIN_EOS OR PLUGINS_ALL)
  add_subdirectory(eos_support)
endif()

option(PLUGIN_METEOR "Enable the Meteor (HRPT, LRPT, etc) support plugin" OFF)

if(PLUGIN_METEOR OR PLUGINS_ALL)
  add_subdirectory(meteor_support)
endif()

option(PLUGIN_JPSS "Enable the JPSS (SNPP, JPSS-1, etc) support plugin" OFF)

if(PLUGIN_JPSS OR PLUGINS_ALL)
  add_subdirectory(jpss_support)
endif()

option(PLUGIN_GOES "Enable the GOES (GVAR, HRIT, GRB, etc) support plugin" OFF)

if(PLUGIN_GOES OR PLUGINS_ALL)
  add_subdirectory(goes_support)
endif()

option(PLUGIN_ELEKTRO_ARKTIKA
       "Enable the Elektro/Arktika (RDAS, xRIT, etc) support plugin" OFF)

if(PLUGIN_ELEKTRO_ARKTIKA OR PLUGINS_ALL)
  add_subdirectory(elektro_arktika_support)
endif()

option(PLUGIN_GK2A "Enable the GK2A (xRIT, etc) support plugin" OFF)

if(PLUGIN_GK2A OR PLUGINS_ALL)
  add_subdirectory(gk2a_support)
endif()

option(
  PLUGIN_NOAA_METOP
  "Enable the NOAA/MetOp POES (AHRPT, HRPT, X-Band dumps, GAC, etc) support plugin"
  OFF)

if(PLUGIN_NOAA_METOP OR PLUGINS_ALL)
  add_subdirectory(noaa_metop_support)
endif()

option(PLUGIN_DMSP "Enable the DMSP support plugin" OFF)

if(PLUGIN_DMSP OR PLUGINS_ALL)
  add_subdirectory(dmsp_support)
endif()

option(PLUGIN_JASON3 "Enable the Jason-3 (S-Band dumps) support plugin" OFF)

if(PLUGIN_JASON3 OR PLUGINS_ALL)
  add_subdirectory(jason3_support)
endif()

option(PLUGIN_AIM "Enable the AIM support plugin" OFF)

if(PLUGIN_AIM OR PLUGINS_ALL)
  add_subdirectory(aim_support)
endif()

option(PLUGIN_WSF "Enable the WSF (WSF-M) support plugin" OFF)

if(PLUGIN_WSF OR PLUGINS_ALL)
  add_subdirectory(wsf_support)
endif()

option(PLUGIN_AWS "Enable the AWS (Sterna) support plugin" OFF)

if(PLUGIN_AWS OR PLUGINS_ALL)
  add_subdirectory(aws_support)
endif()

option(PLUGIN_MATS "Enable the MATS support plugin" OFF)

if(PLUGIN_MATS OR PLUGINS_ALL)
  add_subdirectory(mats_support)
endif()

option(PLUGIN_HINODE "Enable the Hinode support plugin" OFF)

if(PLUGIN_HINODE OR PLUGINS_ALL)
  add_subdirectory(hinode_support)
endif()

option(PLUGIN_OCEANSAT "Enable the Oceansat (X-Band, etc) support plugin" OFF)

if(PLUGIN_OCEANSAT OR PLUGINS_ALL)
  add_subdirectory(oceansat_support)
endif()

option(PLUGIN_LANDSAT "Enable the LandSat support plugin" OFF)

if(PLUGIN_LANDSAT OR PLUGINS_ALL)
  add_subdirectory(landsat_support)
endif()

option(PLUGIN_HIMAWARI "Enable the Himawari (HimawariCast) support plugin" OFF)

if(PLUGIN_HIMAWARI OR PLUGINS_ALL)
  add_subdirectory(himawari_support)
endif()

option(PLUGIN_GEONETCAST "Enable the GeoNetCast support plugin" OFF)

if(PLUGIN_GEONETCAST OR PLUGINS_ALL)
  add_subdirectory(geonetcast_support)
endif()

option(PLUGIN_BLUEWALKER3 "Enable the BlueWalker-3 support plugin" OFF)

if(PLUGIN_BLUEWALKER3 OR PLUGINS_ALL)
  add_subdirectory(bluewalker3_support)
endif()

option(PLUGIN_ANALOG
       "Enable the support plugin for analog protocols such as NOAA APT" OFF)

if(PLUGIN_ANALOG OR PLUGINS_ALL)
  add_subdirectory(analog_support)
endif()

option(PLUGIN_ORBCOMM "Enable the support plugin for the Orbcomm constellation"
       OFF)

if(PLUGIN_ORBCOMM OR PLUGINS_ALL)
  add_subdirectory(orbcomm_support)
endif()

option(PLUGIN_GCOM "Enable the support plugin for the GCOM satellites" OFF)

if(PLUGIN_GCOM OR PLUGINS_ALL)
  add_subdirectory(gcom_support)
endif()

option(PLUGIN_TUBSAT
       "Enable the support plugin for the TUBSAT satellites (TUBIN, etc)" OFF)

if(PLUGIN_TUBSAT OR PLUGINS_ALL)
  add_subdirectory(tubsat_support)
endif()

option(PLUGIN_UMKA "Enable the support plugin for the UmKA satellite" OFF)

if(PLUGIN_UMKA OR PLUGINS_ALL)
  add_subdirectory(umka_support)
endif()

option(PLUGIN_DSCOVR "Enable the DSCOVR support plugin" OFF)

if(PLUGIN_DSCOVR OR PLUGINS_ALL)
  add_subdirectory(dscovr_support)
endif()

option(PLUGIN_STEREO "Enable the support plugin for the STEREO probes" OFF)

if(PLUGIN_STEREO OR PLUGINS_ALL)
  add_subdirectory(stereo_support)
endif()

option(PLUGIN_INMARSAT "Enable the support plugin for Inmarsat" OFF)

if(PLUGIN_INMARSAT OR PLUGINS_ALL)
  add_subdirectory(inmarsat_support)
endif()

option(PLUGIN_CUBESAT "Enable the support plugin for CubeSats" OFF)

if(PLUGIN_CUBESAT OR PLUGINS_ALL)
  add_subdirectory(cubesat_support)
endif()

option(PLUGIN_OTHERS "Enable the support plugin for a few other random satellites" OFF)

if(PLUGIN_OTHERS OR PLUGINS_ALL)
  add_subdirectory(others_support)
endif()

option(PLUGIN_OFFICIAL_PRODUCTS "Enable the support plugin for official satellite products" OFF)

if(PLUGIN_OFFICIAL_PRODUCTS OR PLUGINS_ALL)
  add_subdirectory(official_products_support)
endif()

option(PLUGIN_DVB "Enable the support plugin for DVB Standards (DVB-S, DVB-S2)" OFF)

if(PLUGIN_DVB OR PLUGINS_ALL)
  add_subdirectory(dvb_support)
endif()

option(PLUGIN_CLUSTER "Enable the CLUSTER support plugin" OFF)

if(PLUGIN_CLUSTER OR PLUGINS_ALL)
  add_subdirectory(cluster_support)
endif()

option(PLUGIN_METEOSAT "Enable the Meteosat (MSG Raw data) support plugin" OFF)

if(PLUGIN_METEOSAT OR PLUGINS_ALL)
  add_subdirectory(meteosat_support)
endif()

# add_subdirectory(sample)
option(PLUGIN_GVAR_EXTENDED "Enable the GVAR Extended plugin" OFF)

if(PLUGIN_GVAR_EXTENDED)
  add_subdirectory(gvar_extended)
endif()

# ##############################################################################
option(PLUGIN_SIMD_SSE41 "Enable SIMD SSE41 plugin" ON)

if(PLUGIN_SIMD_SSE41)
  add_subdirectory(simd_extensions/simd_sse41)
endif()

option(PLUGIN_SIMD_NEON "Enable SIMD NEON plugin" ON)

if(PLUGIN_SIMD_NEON)
  add_subdirectory(simd_extensions/simd_neon)
endif()

option(PLUGIN_SIMD_AVX2 "Enable SIMD AVX2 plugin" ON)

if(PLUGIN_SIMD_AVX2)
  add_subdirectory(simd_extensions/simd_avx2)
endif()

# ##############################################################################
option(PLUGIN_AIRSPY_SDR_SUPPORT "Enable Airspy SDR Support plugin" ON)

if(PLUGIN_AIRSPY_SDR_SUPPORT)
  add_subdirectory(sdr_sources/airspy_sdr_support)
endif()

option(PLUGIN_AIRSPYHF_SDR_SUPPORT "Enable AirspyHF SDR Support plugin" ON)

if(PLUGIN_AIRSPYHF_SDR_SUPPORT)
  add_subdirectory(sdr_sources/airspyhf_sdr_support)
endif()

option(PLUGIN_HACKRF_SDR_SUPPORT "Enable HackRF SDR Support plugin" ON)

if(PLUGIN_HACKRF_SDR_SUPPORT)
  add_subdirectory(sdr_sources/hackrf_sdr_support)
endif()

option(PLUGIN_LIMESDR_SDR_SUPPORT "Enable LimeSDR SDR Support plugin" ON)

if(PLUGIN_LIMESDR_SDR_SUPPORT)
  add_subdirectory(sdr_sources/limesdr_sdr_support)
endif()

option(PLUGIN_SDRPLAY_SDR_SUPPORT "Enable SDRPlay SDR Support plugin" ON)

if(PLUGIN_SDRPLAY_SDR_SUPPORT)
  add_subdirectory(sdr_sources/sdrplay_sdr_support)
endif()

option(PLUGIN_PLUTOSDR_SDR_SUPPORT "Enable PlutoSDR SDR Support plugin" ON)

if(PLUGIN_PLUTOSDR_SDR_SUPPORT)
  add_subdirectory(sdr_sources/plutosdr_sdr_support)
endif()

option(PLUGIN_BLADERF_SDR_SUPPORT "Enable BladeRF SDR Support plugin" ON)

if(PLUGIN_BLADERF_SDR_SUPPORT)
  add_subdirectory(sdr_sources/bladerf_sdr_support)
endif()

option(PLUGIN_USRP_SDR_SUPPORT "Enable USRP SDR Support plugin" ON)

if(PLUGIN_USRP_SDR_SUPPORT)
  add_subdirectory(sdr_sources/usrp_sdr_support)
endif()

option(PLUGIN_RTLSDR_SDR_SUPPORT "Enable RTL-SDR SDR Support plugin" ON)

if(PLUGIN_RTLSDR_SDR_SUPPORT)
  add_subdirectory(sdr_sources/rtlsdr_sdr_support)
endif()

option(PLUGIN_MIRISDR_SDR_SUPPORT "Enable MiriSDR SDR Support plugin" ON)

if(PLUGIN_MIRISDR_SDR_SUPPORT)
  add_subdirectory(sdr_sources/mirisdr_sdr_support)
endif()

option(PLUGIN_SPYSERVER_SUPPORT "Enable SpyServer Support plugin" ON)

if(PLUGIN_SPYSERVER_SUPPORT)
  add_subdirectory(sdr_sources/spyserver_support)
endif()

option(PLUGIN_RTLTCP_SUPPORT "Enable RTL-TCP Support plugin" ON)

if(PLUGIN_RTLTCP_SUPPORT)
  add_subdirectory(sdr_sources/rtltcp_support)
endif()

option(PLUGIN_SDRPP_SERVER_SUPPORT "Enable SDR++ Server Support plugin" ON)

if(PLUGIN_SDRPP_SERVER_SUPPORT)
  add_subdirectory(sdr_sources/sdrpp_server_support)
endif()

option(PLUGIN_AARONIA_SDR_SUPPORT "Enable Aaronia Spectran Support plugin" OFF)

if(PLUGIN_AARONIA_SDR_SUPPORT)
  add_subdirectory(sdr_sources/aaronia_sdr_support)
endif()

option(PLUGIN_RFNM_SDR_SUPPORT "Enable RFNM Support plugin" ON)

if(PLUGIN_RFNM_SDR_SUPPORT)
  add_subdirectory(sdr_sources/rfnm_sdr_support)
endif()

option(PLUGIN_RTAUDIO_SDR_SUPPORT "Enable RtAudio Source Support plugin" OFF)

if(PLUGIN_RTAUDIO_SDR_SUPPORT)
  add_subdirectory(sdr_sources/rtaudio_sdr_support)
endif()

option(PLUGIN_NET_SOURCE_SDR_SUPPORT "Enable Network Source Support plugin" ON)

if(PLUGIN_NET_SOURCE_SDR_SUPPORT)
  add_subdirectory(sdr_sources/net_source_support)
endif()

option(PLUGIN_REMOTE_SDR_SUPPORT "Enable Remote SDR Support plugin (WIP!)" ON)

if(PLUGIN_REMOTE_SDR_SUPPORT)
  add_subdirectory(sdr_sources/remote_sdr_support)
endif()

# Disable by default, sort of experimental
option(PLUGIN_SDDC_SDR_SUPPORT
       "Enable SDDC (RX666, RX888, etc) SDR Support plugin" OFF)

if(PLUGIN_SDDC_SDR_SUPPORT)
  add_subdirectory(sdr_sources/sddc_sdr_support)
endif()

# NOT recommended
option(PLUGIN_SOAPY_SDR_SUPPORT
       "Enable Soapy SDR Support plugin (NOT RECOMMENDED!)" OFF)

if(PLUGIN_SOAPY_SDR_SUPPORT)
  add_subdirectory(sdr_sources/soapy_sdr_support)
endif()

# ##############################################################################
option(PLUGIN_RTAUDIO_SINK "Enable RtAudio Audio Sink plugin" OFF)

if(PLUGIN_RTAUDIO_SINK)
  add_subdirectory(audio_sinks/rtaudio_audio_sink)
endif()

option(PLUGIN_PORTAUDIO_SINK "Enable PortAudio Audio Sink plugin" ON)

if(PLUGIN_PORTAUDIO_SINK)
  add_subdirectory(audio_sinks/portaudio_audio_sink)
endif()

option(PLUGIN_AAUDIO_SINK "Enable AAudio Audio Sink plugin" ON)

if(PLUGIN_AAUDIO_SINK)
  add_subdirectory(audio_sinks/aaudio_audio_sink)
endif()

# ##############################################################################
option(PLUGIN_BOCHUM_SUPPORT "Enable Bochum-specific plugin" OFF)

if(PLUGIN_BOCHUM_SUPPORT)
  add_subdirectory(bochum_support)
endif()

# ##############################################################################
option(PLUGIN_STANDARD_CPP_COMPOS "Enable Standard C++ Composites plugin" OFF)

if(PLUGIN_STANDARD_CPP_COMPOS OR PLUGINS_ALL)
  add_subdirectory(standard_cpp_compos_support)
endif()

# ##############################################################################
option(PLUGIN_BITVIEW_APP "Enable BitView Application (Very WIP)" OFF)

if(PLUGIN_BITVIEW_APP)
  add_subdirectory(bitview_app)
endif()

=== src-core/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
include(CheckLibraryExists)
include(CheckIncludeFileCXX)
include(CheckCSourceCompiles)
include(CMakePushCheckState)
include(CheckCCompilerFlag)

file(GLOB_RECURSE SatDump_core_CPPS *.cpp
    libs/aec/*.c
    libs/predict/*.c
    libs/bzlib/*.c
    libs/miniz/*.c
    libs/libtom/*.c
    libs/jpeg/*.c
    libs/jpeg12/*.c
    libs/dlfcn/dlfcn.c
    common/map/maidenhead.c
    libs/correct/*.c
    libs/openjp2/*.c
    libs/deepspace-turbo/*.c
    libs/bzlib/*.c
    libs/tiny-regex-c/*.c
    libs/lua/onelua.c
)

find_package(PkgConfig)

add_library(satdump_core SHARED ${SatDump_core_CPPS})
target_include_directories(satdump_core PUBLIC .)

# Set the resources path
if(MSVC OR BUILD_MSVC)
    target_compile_definitions(satdump_core PUBLIC RESOURCES_PATH="./")
    target_compile_definitions(satdump_core PUBLIC LIBRARIES_PATH="./")
else()
    target_compile_definitions(satdump_core PUBLIC RESOURCES_PATH="${CMAKE_INSTALL_PREFIX}/share/satdump/")
    target_compile_definitions(satdump_core PUBLIC LIBRARIES_PATH="${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/satdump/")
endif()

# We have to... For MSVC
if(BUILD_OPENCL)
    target_compile_definitions(satdump_core PUBLIC USE_OPENCL=1)
endif()

# Threads
find_package(Threads REQUIRED)
target_link_libraries(satdump_core PUBLIC Threads::Threads)

# Armadillo
find_package(Armadillo)

if(ARMADILLO_FOUND)
    target_compile_definitions(satdump_core PUBLIC HAVE_ARMADILLO="1")
    target_link_libraries(satdump_core PUBLIC ${ARMADILLO_LIBRARIES})
    target_include_directories(satdump_core PUBLIC ${ARMADILLO_INCLUDE_DIRS})
    message("-- Building with Armadillo!")
endif()

# OpenCL if we found it
if(BUILD_OPENCL AND NOT ANDROID)
    target_link_libraries(satdump_core PUBLIC ${OpenCL_LIBRARIES})
endif()

# OpenMP Linking for macOS
if(APPLE AND BUILD_OPENMP)
    target_link_libraries(satdump_core PUBLIC omp)
endif()

if(BUILD_ZIQ2)
    target_compile_definitions(satdump_core PUBLIC BUILD_ZIQ2="1")
endif()

if(MSVC)
    # Jemalloc: TODO
    target_link_libraries(satdump_core PUBLIC shlwapi)
    target_link_libraries(satdump_core PUBLIC volk.dll)
    target_link_libraries(satdump_core PUBLIC libpng16.dll)
    target_link_libraries(satdump_core PUBLIC fftw3f.dll)
    target_link_libraries(satdump_core PUBLIC nng.dll)
    target_link_libraries(satdump_core PUBLIC tiff.dll)
    target_link_libraries(satdump_core PUBLIC libcurl.dll)

    if(BUILD_ZIQ)
        target_link_libraries(satdump_core PUBLIC zstd.dll)
        target_compile_definitions(satdump_core PUBLIC BUILD_ZIQ="1")
    endif()

    target_include_directories(satdump_core PUBLIC libs/lua)
    target_link_libraries(satdump_core PUBLIC ws2_32)
elseif(ANDROID)
    # Jemalloc
    # TODO

    # VOLK
    target_link_libraries(satdump_core PUBLIC volk cpufeatures m log dl)
    target_include_directories(satdump_core PUBLIC ../volk_includes)

    # LibPNG
    target_link_libraries(satdump_core PUBLIC png zlib)

    # FFTW3
    target_link_libraries(satdump_core PUBLIC fftw)

    # NNG
    target_link_libraries(satdump_core PUBLIC nng)

    # cURL
    target_link_libraries(satdump_core PUBLIC curl wolfssl)

    # Libzstd
    target_link_libraries(satdump_core PUBLIC zstd)
    target_compile_definitions(satdump_core PUBLIC BUILD_ZIQ="1")

    # Tiff
    target_link_libraries(satdump_core PUBLIC tiff)

    target_include_directories(satdump_core PUBLIC libs/lua)
else()
    if(NOT APPLE)
        target_link_libraries(satdump_core PUBLIC stdc++fs)

        # Jemalloc
        find_package(Jemalloc REQUIRED)
        target_include_directories(satdump_core PUBLIC ${JEMALLOC_INCLUDE_DIR})
        target_link_libraries(satdump_core PUBLIC ${JEMALLOC_LIBRARY})
    endif()

    # VOLK
    pkg_check_modules(VOLK REQUIRED volk)
    check_cxx_source_compiles("#include <volk/volk_alloc.hh>\n int main() { return 0; }" VOLK_HAS_ALLOC)

    if(NOT VOLK_HAS_ALLOC)
        message(STATUS "VOLK does not have volk_alloc.hh, including volk_includes")
        target_include_directories(satdump_core PUBLIC ../volk_includes) # If we're running VOLK 1.0, include our own volk_alloc
    endif()

    target_include_directories(satdump_core PUBLIC ${volk_INCLUDE_DIRS})
    target_link_libraries(satdump_core PUBLIC volk)
    set(CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES} volk) # We need to test stuff in volk later
    set(CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES} ${volk_INCLUDE_DIRS}) # We need to test stuff in volk later

    # LibPNG
    if(WIN32 AND NOT MINGW)
        find_package(PNG CONFIG REQUIRED)
    else()
        find_package(PNG REQUIRED)
    endif()

    target_link_libraries(satdump_core PUBLIC PNG::PNG)

    # FFTW3
    pkg_check_modules(FFTW3 REQUIRED fftw3f)
    target_link_libraries(satdump_core PUBLIC ${FFTW3_LIBRARIES})

    # NNG
    find_library(NNG_LIBRARY nng REQUIRED)
    target_link_libraries(satdump_core PUBLIC ${NNG_LIBRARY})

    if(BUILD_ZIQ)
        # zstd
        find_library(ZSTD_LIBRARY zstd REQUIRED)
        target_link_libraries(satdump_core PUBLIC ${ZSTD_LIBRARY})
        target_compile_definitions(satdump_core PUBLIC BUILD_ZIQ="1")
    endif()

    # Lua
    target_include_directories(satdump_core PUBLIC libs/lua)

    # Curl
    find_package(CURL REQUIRED)

    if(CURL_FOUND)
        target_link_libraries(satdump_core PUBLIC ${CURL_LIBRARIES})
        target_include_directories(satdump_core PUBLIC ${CURL_INCLUDE_DIRS})
        message("-- Building with curl!")
    endif()

    # Dynamic linking
    target_link_libraries(satdump_core PUBLIC dl)

    # Tiff
    find_library(TIFF_LIBRARY tiff REQUIRED)
    target_link_libraries(satdump_core PUBLIC ${TIFF_LIBRARY})

    include(CheckCXXSourceCompiles)

    if(NOT APPLE)
        # Check system has volk_32fc_x2_add_32fc
        check_cxx_source_compiles("#include <volk/volk.h>\n int main() { volk_32fc_x2_add_32fc(nullptr,nullptr,nullptr,0); return 0; }" VOLK_HAS_volk_32fc_x2_add_32fc)

        if(NOT VOLK_HAS_volk_32fc_x2_add_32fc)
            target_compile_definitions(satdump_core PUBLIC VOLK_NO_volk_32fc_x2_add_32fc="1")
        endif()
    endif()
endif()

if(APPLE)
    target_link_libraries(satdump_core PUBLIC "-framework CoreGraphics")
endif()

# Install
if(MSVC OR BUILD_MSVC)
    install(TARGETS satdump_core DESTINATION ${CMAKE_INSTALL_BINDIR} RUNTIME_DEPENDENCY_SET satdump_deps)
else()
    install(TARGETS satdump_core DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif()

install(DIRECTORY . DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/satdump FILES_MATCHING PATTERN "*.h")
install(DIRECTORY . DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/satdump FILES_MATCHING PATTERN "*.hpp")

=== plugins/dscovr_support/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
project(dscovr_support)

file(GLOB_RECURSE dscovr_support_CPPS *.cpp)
add_library(dscovr_support SHARED ${dscovr_support_CPPS})
target_link_libraries(dscovr_support PUBLIC satdump_core)
target_include_directories(dscovr_support PUBLIC src)

install(TARGETS dscovr_support DESTINATION ${CMAKE_INSTALL_LIBDIR}/satdump/plugins)

=== plugins/fengyun2_support/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
project(fengyun2_support)


file(GLOB_RECURSE fengyun2_support_CPPS *.cpp)
add_library(fengyun2_support SHARED ${fengyun2_support_CPPS})
target_link_libraries(fengyun2_support PUBLIC satdump_core)
target_include_directories(fengyun2_support PUBLIC src)

install(TARGETS fengyun2_support DESTINATION ${CMAKE_INSTALL_LIBDIR}/satdump/plugins)

=== plugins/gcom_support/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
project(gcom_support)


file(GLOB_RECURSE gcom_support_CPPS *.cpp)
add_library(gcom_support SHARED ${gcom_support_CPPS})
target_link_libraries(gcom_support PUBLIC satdump_core)
target_include_directories(gcom_support PUBLIC src)

install(TARGETS gcom_support DESTINATION ${CMAKE_INSTALL_LIBDIR}/satdump/plugins)

=== plugins/landsat_support/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
project(landsat_support)

file(GLOB_RECURSE landsat_support_CPPS *.cpp)
add_library(landsat_support SHARED ${landsat_support_CPPS})
target_link_libraries(landsat_support PUBLIC satdump_core)
target_include_directories(landsat_support PUBLIC src)

install(TARGETS landsat_support DESTINATION ${CMAKE_INSTALL_LIBDIR}/satdump/plugins)

=== plugins/meteosat_support/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
project(meteosat_support)

file(GLOB_RECURSE meteosat_support_CPPS *.cpp)
add_library(meteosat_support SHARED ${meteosat_support_CPPS})
target_link_libraries(meteosat_support PUBLIC satdump_core)
target_include_directories(meteosat_support PUBLIC src)

install(TARGETS meteosat_support DESTINATION ${CMAKE_INSTALL_LIBDIR}/satdump/plugins)

=== plugins/official_products_support/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
project(official_products_support)

find_package(PkgConfig)
pkg_check_modules(HDF5 hdf5)
if(${HDF5_FOUND})

  # Core Plugin
  file(
    GLOB_RECURSE
    official_products_support_CPPS
    main.cpp
    file_utils/*.cpp
    fcidecomp/*.c
    fcidecomp/*.cpp
    off2pro/*.cpp
    nc2pro/*.cpp
    nat2pro/*.cpp)

  add_library(official_products_support SHARED
              ${official_products_support_CPPS})
  target_link_libraries(official_products_support PUBLIC satdump_core)
  target_include_directories(official_products_support PUBLIC src)

  target_include_directories(official_products_support
                             PUBLIC ${HDF5_INCLUDE_DIRS})
  target_link_directories(official_products_support PUBLIC ${HDF5_LIBRARY_DIRS})
  target_link_libraries(official_products_support PUBLIC hdf5 hdf5_hl)

  if(MSVC OR BUILD_MSVC)
    install(
      TARGETS official_products_support
      DESTINATION ${CMAKE_INSTALL_LIBDIR}/satdump/plugins
      RUNTIME_DEPENDENCY_SET satdump_deps)
  else()
    install(TARGETS official_products_support
            DESTINATION ${CMAKE_INSTALL_LIBDIR}/satdump/plugins)
  endif()

  # Loader plugin
  if(BUILD_GUI)
    file(GLOB_RECURSE loader_CPPS main_loader.cpp loader/*.cpp)
    add_library(official_products_loader_support SHARED ${loader_CPPS})
    target_link_libraries(official_products_loader_support
                          PUBLIC official_products_support satdump_interface)

    if(MSVC OR BUILD_MSVC)
      install(
        TARGETS official_products_loader_support
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/satdump/plugins
        RUNTIME_DEPENDENCY_SET satdump_deps)
    else()
      install(TARGETS official_products_loader_support
              DESTINATION ${CMAKE_INSTALL_LIBDIR}/satdump/plugins)
    endif()
  endif()

endif()

=== plugins/proba_support/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
project(proba_support)


file(GLOB_RECURSE proba_support_CPPS *.cpp)
add_library(proba_support SHARED ${proba_support_CPPS})
target_link_libraries(proba_support PUBLIC satdump_core)
target_include_directories(proba_support PUBLIC src)

install(TARGETS proba_support DESTINATION ${CMAKE_INSTALL_LIBDIR}/satdump/plugins)

=== tools/cbor2json/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

file(GLOB_RECURSE SatDump_testing_CPPS *.cpp)

add_executable(cbor2json ${SatDump_testing_CPPS})
target_include_directories(cbor2json PUBLIC src-testing src-core)

# Link against the core
target_link_libraries(cbor2json PUBLIC satdump_core)

=== tools/dvbs2_mod/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

file(GLOB_RECURSE SatDump_testing_CPPS *.cpp)

add_executable(dvbs2_mod ${SatDump_testing_CPPS})
target_include_directories(dvbs2_mod PUBLIC src-testing src-core ../../plugins/dvb_support)

# Link against the core
target_link_libraries(dvbs2_mod PUBLIC satdump_core dvb_support)

=== debian/changelog ===
satdump (1.2.2-1build1) questing; urgency=medium

  * Rebuild against latest uhd

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sat, 03 May 2025 20:06:35 -0400

satdump (1.2.2-1) unstable; urgency=medium

  * Update d/watch to version 4 for real
  * d/watch ignore -winxp releases
  * New upstream version 1.2.2
  * Provide Appstream metadata for Satdump
  * Update overrides. Add libsatdump_interface and drop spelling error
  * Update d/rules to be verbose
  * Update d/copyright for new files
  * Update build dependencies to support more hardware
  * Bump standards version to 4.7.2. No changes required
  * Drop B-D ocl-icd-opencl-dev and intel-opencl-icd for Trixie

 -- Apostolos Kefalas <sv1ljj@raag.org>  Tue, 01 Apr 2025 13:05:42 +0300

=== debian/control ===
Source: satdump
Section: hamradio
Priority: optional
Maintainer: Apostolos Kefalas <sv1ljj@raag.org>
Uploaders: Alex Myczko <tar@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               pkgconf,
               libfftw3-dev,
	       libtiff-dev,
               libjemalloc-dev,
	       libcurl4-openssl-dev,
               libvolk-dev|libvolk2-dev,
               libpng-dev,
               libnng-dev,
	       portaudio19-dev,
               libhdf5-dev,
               librtlsdr-dev,
               libhackrf-dev,
               libairspy-dev,
               libairspyhf-dev,
               libad9361-dev, libiio-dev,
               liblimesuite-dev|liblimesuite22.09-1,
	       libuhd-dev, libboost-dev,
               libbladerf-dev,
               libglfw3-dev,
	       zenity,
               libzstd-dev,
# Below B-D are optional, but recommended as it drastically increases
# speed of some operations
               libomp-dev [amd64 arm64 armhf mips64el ppc64el ppc64 riscv64],
	       libarmadillo-dev
Standards-Version: 4.7.2
Homepage: https://www.satdump.org
Vcs-Git: https://salsa.debian.org/svone/satdump.git
Vcs-Browser: https://salsa.debian.org/svone/satdump
Rules-Requires-Root: no

Package: satdump
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, satdump-data (= ${source:Version})
Description: Generic satellite data processing software
 It is a one-stop-shop that provides all the necessary
 stages to get from satellite transmission to actual products.
 Features:
   * Support of many SDRs such as RTL-SDR, Airspy, HackRF, BladeRF,
     LimeSDR, PlutoSDR, etc.
   * Recording of radio basebands from your SDR
   * Decoding and processing the data from over 90 different satellites
     and even space probes.
   * Live decoding of supported satellite links such as APT, LRPT, HRPT,
     LRIT, HRIT and many more.
   * Image and data decoding from satellites such as NOAA 15-18-19,
     Meteor-M, GOES, Elektro-L, Metop, FengYun, etc.
   * Calibrated and georefrenced L1b products output on select satellites,
     such as Sea Surface Temperature, Microphysics, etc. ready to use for
     scientific applications such as numerical weather forecasts.
   * Support for projecting the satellite imagery over a map, including
     layering with other instruments or satellites.
   * Inmarsat Aero and STD-C EGC messages decoding.
   * Scheduler and rotator control for automated satellite stations.
   * Ingestor for automated geostationary weather satellites reception.
 .
 This package provides satdump GUI, CLI and server.

Package: satdump-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Breaks: satdump (<<1.2.0)
Replaces: satdump(<<1.2.0)
Recommends: satdump
Description: Data files required for proper operation of satdump
 It is a one-stop-shop that provides all the necessary
 stages to get from satellite transmission to actual products.
 .
 This package provides data files of satdump.

## satdump 1.2.2%2Bgb79af48

=== plugins/jason3_support/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
project(jason3_support)


file(GLOB_RECURSE jason3_support_CPPS *.cpp)
add_library(jason3_support SHARED ${jason3_support_CPPS})
target_link_libraries(jason3_support PUBLIC satdump_core)
target_include_directories(jason3_support PUBLIC src)

install(TARGETS jason3_support DESTINATION ${CMAKE_INSTALL_LIBDIR}/satdump/plugins)

=== plugins/sdr_sources/rtlsdr_sdr_support/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
project(rtlsdr_sdr_support)


find_library(RTLSDR_LIBRARY rtlsdr)

if(RTLSDR_LIBRARY OR MSVC OR ANDROID)
    message("Building with RTL-SDR support")
    file(GLOB_RECURSE rtlsdr_sdr_support_CPPS *.cpp)
    add_library(rtlsdr_sdr_support SHARED ${rtlsdr_sdr_support_CPPS})
    target_include_directories(rtlsdr_sdr_support PUBLIC src)

    if(MSVC)
        target_link_libraries(rtlsdr_sdr_support PUBLIC satdump_core rtlsdr.dll)
        install(TARGETS rtlsdr_sdr_support DESTINATION ${CMAKE_INSTALL_LIBDIR}/satdump/plugins RUNTIME_DEPENDENCY_SET satdump_deps)
    elseif(ANDROID)
        target_link_libraries(rtlsdr_sdr_support PUBLIC satdump_core rtlsdr usb)
        target_include_directories(rtlsdr_sdr_support PUBLIC ../../../android/deps/librtlsdr)
        install(TARGETS rtlsdr_sdr_support DESTINATION ${CMAKE_INSTALL_LIBDIR}/satdump/plugins)
    else()
        target_link_libraries(rtlsdr_sdr_support PUBLIC satdump_core ${RTLSDR_LIBRARY})
        install(TARGETS rtlsdr_sdr_support DESTINATION ${CMAKE_INSTALL_LIBDIR}/satdump/plugins)
    endif()
else()
    message("RTL-SDR Library could not be found! Not building.")
endif()
